// Code generated by client-gen. DO NOT EDIT.

package versioned

import (
	"fmt"

	memberclusterv1alpha1 "github.com/karmada-io/karmada/pkg/generated/clientset/versioned/typed/membercluster/v1alpha1"
	propagationstrategyv1alpha1 "github.com/karmada-io/karmada/pkg/generated/clientset/versioned/typed/propagationstrategy/v1alpha1"
	discovery "k8s.io/client-go/discovery"
	rest "k8s.io/client-go/rest"
	flowcontrol "k8s.io/client-go/util/flowcontrol"
)

type Interface interface {
	Discovery() discovery.DiscoveryInterface
	MemberclusterV1alpha1() memberclusterv1alpha1.MemberclusterV1alpha1Interface
	PropagationstrategyV1alpha1() propagationstrategyv1alpha1.PropagationstrategyV1alpha1Interface
}

// Clientset contains the clients for groups. Each group has exactly one
// version included in a Clientset.
type Clientset struct {
	*discovery.DiscoveryClient
	memberclusterV1alpha1       *memberclusterv1alpha1.MemberclusterV1alpha1Client
	propagationstrategyV1alpha1 *propagationstrategyv1alpha1.PropagationstrategyV1alpha1Client
}

// MemberclusterV1alpha1 retrieves the MemberclusterV1alpha1Client
func (c *Clientset) MemberclusterV1alpha1() memberclusterv1alpha1.MemberclusterV1alpha1Interface {
	return c.memberclusterV1alpha1
}

// PropagationstrategyV1alpha1 retrieves the PropagationstrategyV1alpha1Client
func (c *Clientset) PropagationstrategyV1alpha1() propagationstrategyv1alpha1.PropagationstrategyV1alpha1Interface {
	return c.propagationstrategyV1alpha1
}

// Discovery retrieves the DiscoveryClient
func (c *Clientset) Discovery() discovery.DiscoveryInterface {
	if c == nil {
		return nil
	}
	return c.DiscoveryClient
}

// NewForConfig creates a new Clientset for the given config.
// If config's RateLimiter is not set and QPS and Burst are acceptable,
// NewForConfig will generate a rate-limiter in configShallowCopy.
func NewForConfig(c *rest.Config) (*Clientset, error) {
	configShallowCopy := *c
	if configShallowCopy.RateLimiter == nil && configShallowCopy.QPS > 0 {
		if configShallowCopy.Burst <= 0 {
			return nil, fmt.Errorf("burst is required to be greater than 0 when RateLimiter is not set and QPS is set to greater than 0")
		}
		configShallowCopy.RateLimiter = flowcontrol.NewTokenBucketRateLimiter(configShallowCopy.QPS, configShallowCopy.Burst)
	}
	var cs Clientset
	var err error
	cs.memberclusterV1alpha1, err = memberclusterv1alpha1.NewForConfig(&configShallowCopy)
	if err != nil {
		return nil, err
	}
	cs.propagationstrategyV1alpha1, err = propagationstrategyv1alpha1.NewForConfig(&configShallowCopy)
	if err != nil {
		return nil, err
	}

	cs.DiscoveryClient, err = discovery.NewDiscoveryClientForConfig(&configShallowCopy)
	if err != nil {
		return nil, err
	}
	return &cs, nil
}

// NewForConfigOrDie creates a new Clientset for the given config and
// panics if there is an error in the config.
func NewForConfigOrDie(c *rest.Config) *Clientset {
	var cs Clientset
	cs.memberclusterV1alpha1 = memberclusterv1alpha1.NewForConfigOrDie(c)
	cs.propagationstrategyV1alpha1 = propagationstrategyv1alpha1.NewForConfigOrDie(c)

	cs.DiscoveryClient = discovery.NewDiscoveryClientForConfigOrDie(c)
	return &cs
}

// New creates a new Clientset for the given RESTClient.
func New(c rest.Interface) *Clientset {
	var cs Clientset
	cs.memberclusterV1alpha1 = memberclusterv1alpha1.New(c)
	cs.propagationstrategyV1alpha1 = propagationstrategyv1alpha1.New(c)

	cs.DiscoveryClient = discovery.NewDiscoveryClient(c)
	return &cs
}
