// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	"time"

	v1alpha1 "github.com/karmada-io/karmada/pkg/apis/membercluster/v1alpha1"
	scheme "github.com/karmada-io/karmada/pkg/generated/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// MemberClustersGetter has a method to return a MemberClusterInterface.
// A group's client should implement this interface.
type MemberClustersGetter interface {
	MemberClusters() MemberClusterInterface
}

// MemberClusterInterface has methods to work with MemberCluster resources.
type MemberClusterInterface interface {
	Create(ctx context.Context, memberCluster *v1alpha1.MemberCluster, opts v1.CreateOptions) (*v1alpha1.MemberCluster, error)
	Update(ctx context.Context, memberCluster *v1alpha1.MemberCluster, opts v1.UpdateOptions) (*v1alpha1.MemberCluster, error)
	UpdateStatus(ctx context.Context, memberCluster *v1alpha1.MemberCluster, opts v1.UpdateOptions) (*v1alpha1.MemberCluster, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.MemberCluster, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.MemberClusterList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.MemberCluster, err error)
	MemberClusterExpansion
}

// memberClusters implements MemberClusterInterface
type memberClusters struct {
	client rest.Interface
}

// newMemberClusters returns a MemberClusters
func newMemberClusters(c *MemberclusterV1alpha1Client) *memberClusters {
	return &memberClusters{
		client: c.RESTClient(),
	}
}

// Get takes name of the memberCluster, and returns the corresponding memberCluster object, and an error if there is any.
func (c *memberClusters) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.MemberCluster, err error) {
	result = &v1alpha1.MemberCluster{}
	err = c.client.Get().
		Resource("memberclusters").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of MemberClusters that match those selectors.
func (c *memberClusters) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.MemberClusterList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.MemberClusterList{}
	err = c.client.Get().
		Resource("memberclusters").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested memberClusters.
func (c *memberClusters) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Resource("memberclusters").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a memberCluster and creates it.  Returns the server's representation of the memberCluster, and an error, if there is any.
func (c *memberClusters) Create(ctx context.Context, memberCluster *v1alpha1.MemberCluster, opts v1.CreateOptions) (result *v1alpha1.MemberCluster, err error) {
	result = &v1alpha1.MemberCluster{}
	err = c.client.Post().
		Resource("memberclusters").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(memberCluster).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a memberCluster and updates it. Returns the server's representation of the memberCluster, and an error, if there is any.
func (c *memberClusters) Update(ctx context.Context, memberCluster *v1alpha1.MemberCluster, opts v1.UpdateOptions) (result *v1alpha1.MemberCluster, err error) {
	result = &v1alpha1.MemberCluster{}
	err = c.client.Put().
		Resource("memberclusters").
		Name(memberCluster.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(memberCluster).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *memberClusters) UpdateStatus(ctx context.Context, memberCluster *v1alpha1.MemberCluster, opts v1.UpdateOptions) (result *v1alpha1.MemberCluster, err error) {
	result = &v1alpha1.MemberCluster{}
	err = c.client.Put().
		Resource("memberclusters").
		Name(memberCluster.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(memberCluster).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the memberCluster and deletes it. Returns an error if one occurs.
func (c *memberClusters) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Resource("memberclusters").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *memberClusters) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Resource("memberclusters").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched memberCluster.
func (c *memberClusters) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.MemberCluster, err error) {
	result = &v1alpha1.MemberCluster{}
	err = c.client.Patch(pt).
		Resource("memberclusters").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
